#include "random.h"


void set_seed(double arg) {
  s10=s11=s12=s20=s21=s22=arg;}


double MRG32k3a()
{
  long    k;
  double p1, p2;
  /* Component 1 */
  p1 = a12 * s11 - a13n * s10;
  k = p1 / m1;
  p1 -= k * m1;  
  if (p1 < 0.0) p1 += m1;
  s10 = s11; s11 = s12; s12 = p1;
  /* Component 2 */
  p2 = a21 * s22 - a23n * s20;
  k = p2 / m2; p2 -= k * m2;
  if (p2 < 0.0) p2 += m2;
  s20 = s21; s21 = s22; s22 = p2;
  /* Combination */
  if (p1 <= p2) return ((p1 - p2 + m1) * norm);
  else return ((p1 - p2) * norm);
}


double ranU01(void)
{
  return MRG32k3a();
}

/* Uniform random int in [i,j] */
int ranUint(int i, int j)
{
  return i + (int) ((j - i + 1.0) * MRG32k3a());
}


void shuffle(int *v, int size) {
  int  k, j, help;
   
  j = size;
   
  for ( j = size-1 ; j > 0 ; j--) {
    k = (int) ( ranU01( ) * j ); 
    help = v[k];
    v[k] = v[j];
    v[j] = help;
  }
}


