#include <errno.h>
#include <unistd.h>


#ifdef WIN32 // Windows Version
#include <sys/timeb.h>

double getCurrentTime() 
{
 _timeb sysTime;
  _ftime(&sysTime);
  return (double) sysTime.time + (double) sysTime.millitm * 1.0E-3;
}
#else // Linux Version
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>

static struct rusage res;
double getCurrentTime() 
{
  /* returns virtual time */
  getrusage( RUSAGE_SELF, &res );
  return (double) res.ru_utime.tv_sec +
    (double) res.ru_stime.tv_sec +
    (double) res.ru_utime.tv_usec * 1.0E-6 +
    (double) res.ru_stime.tv_usec * 1.0E-6;
}
#endif


